;;; thingatpt-utils-test.el  --- more th-at-point edit functions

;; Version: 1.10

;; Copyright (C) 2006, 2007 Andreas Roehler

;; Author: Andreas Roehler <andreas.roehler@easy-emacs.de>

;; Keywords: convenience

;; This file is free software; you can redistribute it

;; and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3, or (at your option) any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301, USA.

;;; Commentary:

;; Information is given with thingatpt-utils-base.el

(require 'thingatpt-utils-base)




(defun th-test (&optional arg) 
  "Checks available THING-atpt forms at point
  Prints forms with values in bufffer `th-test', 
  with ARG also forms, which returned `nil' "
  (interactive "p")
  (let 
      ((pos (point))
       (arg (or arg 1)) 
       (th-fnlist '(
                    alnum-atpt
                    alnum-bounds-atpt
                    alnum-end-position-atpt
                    alnum-copy-atpt
                    alpha-atpt
                    alpha-bounds-atpt
                    alpha-end-position-atpt
                    alpha-copy-atpt
                    ascii-atpt
                    ascii-bounds-atpt
                    ascii-end-position-atpt
                    ascii-copy-atpt
                    backslashed-atpt
                    backslashed-bounds-atpt
                    backslashed-end-position-atpt
                    backslashed-copy-atpt
                    blank-atpt
                    blank-bounds-atpt
                    blank-end-position-atpt
                    blank-copy-atpt
                    braced-atpt
                    braced-bounds-atpt
                    braced-end-position-atpt
                    braced-copy-atpt
                    bracketed-atpt
                    bracketed-bounds-atpt
                    bracketed-end-position-atpt
                    bracketed-copy-atpt
                    cntrl-atpt
                    cntrl-bounds-atpt
                    cntrl-end-position-atpt
                    cntrl-copy-atpt
                    comment-atpt
                    comment-bounds-atpt
                    comment-end-position-atpt
                    comment-copy-atpt
                    csv-atpt
                    csv-bounds-atpt
                    csv-end-position-atpt
                    csv-copy-atpt
                    date-atpt
                    date-bounds-atpt
                    date-end-position-atpt
                    date-copy-atpt
                    defun-atpt
                    defun-bounds-atpt
                    defun-end-position-atpt
                    defun-copy-atpt
                    delimited-atpt
                    delimited-bounds-atpt
                    delimited-end-position-atpt
                    delimited-copy-atpt
                    digit-atpt
                    digit-bounds-atpt
                    digit-end-position-atpt
                    digit-copy-atpt
                    dollared-atpt
                    dollared-bounds-atpt
                    dollared-end-position-atpt
                    dollared-copy-atpt
                    doublequoted-atpt
                    doublequoted-bounds-atpt
                    doublequoted-end-position-atpt
                    doublequoted-copy-atpt
                    email-atpt
                    email-bounds-atpt
                    email-end-position-atpt
                    email-copy-atpt
                    filename-atpt
                    filename-bounds-atpt
                    filename-end-position-atpt
                    filename-copy-atpt
                    float-atpt
                    float-bounds-atpt
                    float-end-position-atpt
                    float-copy-atpt
                    function-atpt
                    function-bounds-atpt
                    function-end-position-atpt
                    function-copy-atpt
                    graph-atpt
                    graph-bounds-atpt
                    graph-end-position-atpt
                    graph-copy-atpt
                    ip-atpt
                    ip-bounds-atpt
                    ip-end-position-atpt
                    ip-copy-atpt
                    isbn-atpt
                    isbn-bounds-atpt
                    isbn-end-position-atpt
                    isbn-copy-atpt
                    line-atpt
                    line-bounds-atpt
                    line-end-position-atpt
                    line-copy-atpt
                    list-atpt
                    list-bounds-atpt
                    list-end-position-atpt
                    list-copy-atpt
                    lower-atpt
                    lower-bounds-atpt
                    lower-end-position-atpt
                    lower-copy-atpt
                    ml-text-atpt
                    ml-text-bounds-atpt
                    ml-text-end-position-atpt
                    ml-text-copy-atpt
                    multibyte-atpt
                    multibyte-bounds-atpt
                    multibyte-end-position-atpt
                    multibyte-copy-atpt
                    nonascii-atpt
                    nonascii-bounds-atpt
                    nonascii-end-position-atpt
                    nonascii-copy-atpt
                    number-atpt
                    number-bounds-atpt
                    number-end-position-atpt
number-copy-atpt
page-atpt
page-bounds-atpt
page-end-position-atpt
page-copy-atpt
paragraph-atpt
paragraph-bounds-atpt
paragraph-end-position-atpt
paragraph-copy-atpt
paren-atpt
paren-bounds-atpt
paren-end-position-atpt
paren-copy-atpt
parentized-atpt
parentized-bounds-atpt
parentized-end-position-atpt
parentized-copy-atpt
phone-atpt
phone-bounds-atpt
phone-end-position-atpt
phone-copy-atpt
print-atpt
print-bounds-atpt
print-end-position-atpt
print-copy-atpt
punct-atpt
punct-bounds-atpt
punct-end-position-atpt
punct-copy-atpt
region-atpt
region-bounds-atpt
region-end-position-atpt
region-copy-atpt
sentence-atpt
sentence-bounds-atpt
sentence-end-position-atpt
sentence-copy-atpt
sexp-atpt
sexp-bounds-atpt
sexp-end-position-atpt
sexp-copy-atpt
singlequoted-atpt
singlequoted-bounds-atpt
singlequoted-end-position-atpt
singlequoted-copy-atpt
slashed-atpt
slashed-bounds-atpt
slashed-end-position-atpt
slashed-copy-atpt
space-atpt
space-bounds-atpt
space-end-position-atpt
space-copy-atpt
string-atpt
string-bounds-atpt
string-end-position-atpt
string-copy-atpt
sh-struct-atpt
sh-struct-bounds-atpt
sh-struct-end-position-atpt
sh-struct-copy-atpt
symbol-atpt
symbol-bounds-atpt
symbol-end-position-atpt
symbol-copy-atpt
unibyte-atpt
unibyte-bounds-atpt
unibyte-end-position-atpt
unibyte-copy-atpt
upper-atpt
upper-bounds-atpt
upper-end-position-atpt
upper-copy-atpt
url-atpt
url-bounds-atpt
url-end-position-atpt
url-copy-atpt
whitespace-atpt
whitespace-bounds-atpt
whitespace-end-position-atpt
whitespace-copy-atpt
word-atpt
word-bounds-atpt
word-end-position-atpt
word-copy-atpt
xdigit-atpt
xdigit-bounds-atpt
xdigit-end-position-atpt
xdigit-copy-atpt)))
    (save-excursion 
      (set-buffer (get-buffer-create "th-test"))
      (erase-buffer)
      (insert (format "Point: %s" pos))
      (newline)) 
    (dolist (elt th-fnlist)
      (let* ((item (funcall elt arg))
	     (output-p (if arg
			   t
			 (cond ((eq nil item)
				nil)
			       ((and (listp item)
				     (eq nil (car item)))
				nil)
			       ((and (stringp item)
				     (string= "" item))
				nil)
			       (t t)))))
	(when output-p
	  (save-excursion 
	    (switch-to-buffer "th-test")
	    (if (listp item)
		(setq item (concat (format "%s" (car item))" "(format "%s" (cdr item)))))
	    (insert (concat (format "%s: " elt) (format "%s \n" item)))))))))

(defun th-mv-test (&optional arg) 
  "Checks available move-THING-atpt forms at point.
  Shows moves while indicating executed form in message-buffer"
  (interactive "p")
  (let 
      ((arg (or arg 1)) 
       (th-mv-fnlist '(
                       alnum-forward-atpt
                       alnum-backward-atpt
                       alpha-forward-atpt
                       alpha-backward-atpt
                       ascii-forward-atpt
                       ascii-backward-atpt
                       backslashed-forward-atpt
                       backslashed-backward-atpt
                       blank-forward-atpt
                       blank-backward-atpt
                       braced-forward-atpt
                       braced-backward-atpt
                       bracketed-forward-atpt
                       bracketed-backward-atpt
                       cntrl-forward-atpt
                       cntrl-backward-atpt
                       comment-forward-atpt
                       comment-backward-atpt
                       csv-forward-atpt
                       csv-backward-atpt
                       date-forward-atpt
                       date-backward-atpt
                       defun-forward-atpt
                       defun-backward-atpt
                       delimited-forward-atpt
                       delimited-backward-atpt
                       digit-forward-atpt
                       digit-backward-atpt
                       dollared-forward-atpt
                       dollared-backward-atpt
                       doublequoted-forward-atpt
                       doublequoted-backward-atpt
                       email-forward-atpt
                       email-backward-atpt
                       filename-forward-atpt
                       filename-backward-atpt
                       float-forward-atpt
                       float-backward-atpt
                       function-forward-atpt
                       function-backward-atpt
                       graph-forward-atpt
                       graph-backward-atpt
                       ip-forward-atpt
                       ip-backward-atpt
                       isbn-forward-atpt
                       isbn-backward-atpt
                       line-forward-atpt
                       line-backward-atpt
                       list-forward-atpt
                       list-backward-atpt
                       lower-forward-atpt
                       lower-backward-atpt
                       ml-text-forward-atpt
                       ml-text-backward-atpt
                       multibyte-forward-atpt
                       multibyte-backward-atpt
nonascii-forward-atpt
nonascii-backward-atpt
number-forward-atpt
number-backward-atpt
page-forward-atpt
page-backward-atpt
paragraph-forward-atpt
paragraph-backward-atpt
paren-forward-atpt
paren-backward-atpt
parentized-forward-atpt
parentized-backward-atpt
phone-forward-atpt
phone-backward-atpt
print-forward-atpt
print-backward-atpt
punct-forward-atpt
punct-backward-atpt
region-forward-atpt
region-backward-atpt
sentence-forward-atpt
sentence-backward-atpt
sexp-forward-atpt
sexp-backward-atpt
singlequoted-forward-atpt
singlequoted-backward-atpt
slashed-forward-atpt
slashed-backward-atpt
space-forward-atpt
space-backward-atpt
string-forward-atpt
string-backward-atpt
sh-struct-forward-atpt
sh-struct-backward-atpt
symbol-forward-atpt
symbol-backward-atpt
unibyte-forward-atpt
unibyte-backward-atpt
upper-forward-atpt
upper-backward-atpt
url-forward-atpt
url-backward-atpt
whitespace-forward-atpt
whitespace-backward-atpt
word-forward-atpt
word-backward-atpt
xdigit-forward-atpt
xdigit-backward-atpt)))
    (save-excursion 
      (dolist (elt th-mv-fnlist)
	(when
	    (functionp (intern-soft elt))
	  (message "   %s" elt)
	  (save-excursion
	    (funcall elt arg)
	    (sit-for th-mv-test-delay))))))
  (message "   %s" "Seems as th-mv-test completed successfully!"))

;; (setq delim-thingsat-fn 'symbol-at)

(defcustom th-delimtest-delay  1 
  "Seconds to wait until next delimtest functioncall" 
  
  :type 'number
  :group 'convenience)

(defcustom th-mv-test-delay 1 
  "" 
  :type 'number
  :group 'convenience)

(defun th-delimtest (&optional arg) 
  " "
  (interactive "*p")
  (let ((arg (or arg 1)) 
	(pos (point))
	(fns-test '(
                    alnum-backslash-atpt
                    alnum-brace-atpt
                    alnum-bracket-atpt
                    alnum-dollar-atpt
                    alnum-doublequote-atpt
                    alnum-parentize-atpt
                    alnum-separate-atpt
                    alnum-singlequote-atpt
                    alnum-slash-atpt
                    alnum-comment-atpt
                    alpha-backslash-atpt
                    alpha-brace-atpt
                    alpha-bracket-atpt
                    alpha-dollar-atpt
                    alpha-doublequote-atpt
                    alpha-parentize-atpt
                    alpha-separate-atpt
                    alpha-singlequote-atpt
                    alpha-slash-atpt
                    alpha-comment-atpt
                    ascii-backslash-atpt
                    ascii-brace-atpt
                    ascii-bracket-atpt
                    ascii-dollar-atpt
                    ascii-doublequote-atpt
                    ascii-parentize-atpt
                    ascii-separate-atpt
                    ascii-singlequote-atpt
                    ascii-slash-atpt
                    ascii-comment-atpt
                    backslashed-backslash-atpt
                    backslashed-brace-atpt
                    backslashed-bracket-atpt
                    backslashed-dollar-atpt
                    backslashed-doublequote-atpt
                    backslashed-parentize-atpt
                    backslashed-separate-atpt
                    backslashed-singlequote-atpt
                    backslashed-slash-atpt
                    backslashed-comment-atpt
                    blank-backslash-atpt
                    blank-brace-atpt
                    blank-bracket-atpt
                    blank-dollar-atpt
                    blank-doublequote-atpt
                    blank-parentize-atpt
                    blank-separate-atpt
                    blank-singlequote-atpt
                    blank-slash-atpt
                    blank-comment-atpt
                    braced-backslash-atpt
                    braced-brace-atpt
                    braced-bracket-atpt
                    braced-dollar-atpt
                    braced-doublequote-atpt
                    braced-parentize-atpt
                    braced-separate-atpt
                    braced-singlequote-atpt
                    braced-slash-atpt
                    braced-comment-atpt
                    bracketed-backslash-atpt
                    bracketed-brace-atpt
                    bracketed-bracket-atpt
                    bracketed-dollar-atpt
                    bracketed-doublequote-atpt
                    bracketed-parentize-atpt
                    bracketed-separate-atpt
                    bracketed-singlequote-atpt
                    bracketed-slash-atpt
                    bracketed-comment-atpt
                    cntrl-backslash-atpt
                    cntrl-brace-atpt
                    cntrl-bracket-atpt
                    cntrl-dollar-atpt
                    cntrl-doublequote-atpt
                    cntrl-parentize-atpt
                    cntrl-separate-atpt
                    cntrl-singlequote-atpt
                    cntrl-slash-atpt
                    cntrl-comment-atpt
                    comment-backslash-atpt
                    comment-brace-atpt
                    comment-bracket-atpt
                    comment-dollar-atpt
                    comment-doublequote-atpt
                    comment-parentize-atpt
                    comment-separate-atpt
                    comment-singlequote-atpt
                    comment-slash-atpt
                    comment-comment-atpt
                    csv-backslash-atpt
                    csv-brace-atpt
                    csv-bracket-atpt
                    csv-dollar-atpt
                    csv-doublequote-atpt
                    csv-parentize-atpt
                    csv-separate-atpt
                    csv-singlequote-atpt
                    csv-slash-atpt
                    csv-comment-atpt
                    date-backslash-atpt
                    date-brace-atpt
                    date-bracket-atpt
                    date-dollar-atpt
                    date-doublequote-atpt
                    date-parentize-atpt
                    date-separate-atpt
                    date-singlequote-atpt
                    date-slash-atpt
                    date-comment-atpt
                    defun-backslash-atpt
                    defun-brace-atpt
                    defun-bracket-atpt
                    defun-dollar-atpt
                    defun-doublequote-atpt
                    defun-parentize-atpt
                    defun-separate-atpt
                    defun-singlequote-atpt
                    defun-slash-atpt
                    defun-comment-atpt
                    delimited-backslash-atpt
                    delimited-brace-atpt
                    delimited-bracket-atpt
                    delimited-dollar-atpt
                    delimited-doublequote-atpt
                    delimited-parentize-atpt
                    delimited-separate-atpt
                    delimited-singlequote-atpt
                    delimited-slash-atpt
                    delimited-comment-atpt
                    digit-backslash-atpt
                    digit-brace-atpt
                    digit-bracket-atpt
                    digit-dollar-atpt
                    digit-doublequote-atpt
                    digit-parentize-atpt
                    digit-separate-atpt
                    digit-singlequote-atpt
                    digit-slash-atpt
                    digit-comment-atpt
                    dollared-backslash-atpt
                    dollared-brace-atpt
                    dollared-bracket-atpt
                    dollared-dollar-atpt
                    dollared-doublequote-atpt
                    dollared-parentize-atpt
                    dollared-separate-atpt
                    dollared-singlequote-atpt
                    dollared-slash-atpt
                    dollared-comment-atpt
                    doublequoted-backslash-atpt
                    doublequoted-brace-atpt
                    doublequoted-bracket-atpt
                    doublequoted-dollar-atpt
                    doublequoted-doublequote-atpt
                    doublequoted-parentize-atpt
                    doublequoted-separate-atpt
                    doublequoted-singlequote-atpt
                    doublequoted-slash-atpt
                    doublequoted-comment-atpt
                    email-backslash-atpt
                    email-brace-atpt
                    email-bracket-atpt
                    email-dollar-atpt
                    email-doublequote-atpt
                    email-parentize-atpt
                    email-separate-atpt
                    email-singlequote-atpt
                    email-slash-atpt
                    email-comment-atpt
                    filename-backslash-atpt
                    filename-brace-atpt
                    filename-bracket-atpt
                    filename-dollar-atpt
                    filename-doublequote-atpt
                    filename-parentize-atpt
                    filename-separate-atpt
                    filename-singlequote-atpt
                    filename-slash-atpt
                    filename-comment-atpt
                    float-backslash-atpt
                    float-brace-atpt
                    float-bracket-atpt
                    float-dollar-atpt
                    float-doublequote-atpt
                    float-parentize-atpt
                    float-separate-atpt
                    float-singlequote-atpt
                    float-slash-atpt
                    float-comment-atpt
                    function-backslash-atpt
                    function-brace-atpt
                    function-bracket-atpt
                    function-dollar-atpt
                    function-doublequote-atpt
                    function-parentize-atpt
                    function-separate-atpt
                    function-singlequote-atpt
                    function-slash-atpt
                    function-comment-atpt
                    graph-backslash-atpt
                    graph-brace-atpt
                    graph-bracket-atpt
                    graph-dollar-atpt
                    graph-doublequote-atpt
                    graph-parentize-atpt
                    graph-separate-atpt
                    graph-singlequote-atpt
                    graph-slash-atpt
                    graph-comment-atpt
                    ip-backslash-atpt
                    ip-brace-atpt
                    ip-bracket-atpt
                    ip-dollar-atpt
                    ip-doublequote-atpt
                    ip-parentize-atpt
                    ip-separate-atpt
                    ip-singlequote-atpt
                    ip-slash-atpt
                    ip-comment-atpt
                    isbn-backslash-atpt
                    isbn-brace-atpt
                    isbn-bracket-atpt
                    isbn-dollar-atpt
                    isbn-doublequote-atpt
                    isbn-parentize-atpt
                    isbn-separate-atpt
                    isbn-singlequote-atpt
                    isbn-slash-atpt
                    isbn-comment-atpt
                    line-backslash-atpt
                    line-brace-atpt
                    line-bracket-atpt
                    line-dollar-atpt
                    line-doublequote-atpt
                    line-parentize-atpt
                    line-separate-atpt
                    line-singlequote-atpt
                    line-slash-atpt
                    line-comment-atpt
                    list-backslash-atpt
                    list-brace-atpt
                    list-bracket-atpt
                    list-dollar-atpt
                    list-doublequote-atpt
                    list-parentize-atpt
                    list-separate-atpt
                    list-singlequote-atpt
                    list-slash-atpt
                    list-comment-atpt
                    lower-backslash-atpt
                    lower-brace-atpt
                    lower-bracket-atpt
                    lower-dollar-atpt
                    lower-doublequote-atpt
                    lower-parentize-atpt
                    lower-separate-atpt
                    lower-singlequote-atpt
                    lower-slash-atpt
                    lower-comment-atpt
                    ml-text-backslash-atpt
                    ml-text-brace-atpt
                    ml-text-bracket-atpt
                    ml-text-dollar-atpt
                    ml-text-doublequote-atpt
                    ml-text-parentize-atpt
                    ml-text-separate-atpt
                    ml-text-singlequote-atpt
                    ml-text-slash-atpt
                    ml-text-comment-atpt
                    multibyte-backslash-atpt
                    multibyte-brace-atpt
multibyte-bracket-atpt
multibyte-dollar-atpt
multibyte-doublequote-atpt
multibyte-parentize-atpt
multibyte-separate-atpt
multibyte-singlequote-atpt
multibyte-slash-atpt
multibyte-comment-atpt
nonascii-backslash-atpt
nonascii-brace-atpt
nonascii-bracket-atpt
nonascii-dollar-atpt
nonascii-doublequote-atpt
nonascii-parentize-atpt
nonascii-separate-atpt
nonascii-singlequote-atpt
nonascii-slash-atpt
nonascii-comment-atpt
number-backslash-atpt
number-brace-atpt
number-bracket-atpt
number-dollar-atpt
number-doublequote-atpt
number-parentize-atpt
number-separate-atpt
number-singlequote-atpt
number-slash-atpt
number-comment-atpt
page-backslash-atpt
page-brace-atpt
page-bracket-atpt
page-dollar-atpt
page-doublequote-atpt
page-parentize-atpt
page-separate-atpt
page-singlequote-atpt
page-slash-atpt
page-comment-atpt
paragraph-backslash-atpt
paragraph-brace-atpt
paragraph-bracket-atpt
paragraph-dollar-atpt
paragraph-doublequote-atpt
paragraph-parentize-atpt
paragraph-separate-atpt
paragraph-singlequote-atpt
paragraph-slash-atpt
paragraph-comment-atpt
paren-backslash-atpt
paren-brace-atpt
paren-bracket-atpt
paren-dollar-atpt
paren-doublequote-atpt
paren-parentize-atpt
paren-separate-atpt
paren-singlequote-atpt
paren-slash-atpt
paren-comment-atpt
parentized-backslash-atpt
parentized-brace-atpt
parentized-bracket-atpt
parentized-dollar-atpt
parentized-doublequote-atpt
parentized-parentize-atpt
parentized-separate-atpt
parentized-singlequote-atpt
parentized-slash-atpt
parentized-comment-atpt
phone-backslash-atpt
phone-brace-atpt
phone-bracket-atpt
phone-dollar-atpt
phone-doublequote-atpt
phone-parentize-atpt
phone-separate-atpt
phone-singlequote-atpt
phone-slash-atpt
phone-comment-atpt
print-backslash-atpt
print-brace-atpt
print-bracket-atpt
print-dollar-atpt
print-doublequote-atpt
print-parentize-atpt
print-separate-atpt
print-singlequote-atpt
print-slash-atpt
print-comment-atpt
punct-backslash-atpt
punct-brace-atpt
punct-bracket-atpt
punct-dollar-atpt
punct-doublequote-atpt
punct-parentize-atpt
punct-separate-atpt
punct-singlequote-atpt
punct-slash-atpt
punct-comment-atpt
region-backslash-atpt
region-brace-atpt
region-bracket-atpt
region-dollar-atpt
region-doublequote-atpt
region-parentize-atpt
region-separate-atpt
region-singlequote-atpt
region-slash-atpt
region-comment-atpt
sentence-backslash-atpt
sentence-brace-atpt
sentence-bracket-atpt
sentence-dollar-atpt
sentence-doublequote-atpt
sentence-parentize-atpt
sentence-separate-atpt
sentence-singlequote-atpt
sentence-slash-atpt
sentence-comment-atpt
sexp-backslash-atpt
sexp-brace-atpt
sexp-bracket-atpt
sexp-dollar-atpt
sexp-doublequote-atpt
sexp-parentize-atpt
sexp-separate-atpt
sexp-singlequote-atpt
sexp-slash-atpt
sexp-comment-atpt
singlequoted-backslash-atpt
singlequoted-brace-atpt
singlequoted-bracket-atpt
singlequoted-dollar-atpt
singlequoted-doublequote-atpt
singlequoted-parentize-atpt
singlequoted-separate-atpt
singlequoted-singlequote-atpt
singlequoted-slash-atpt
singlequoted-comment-atpt
slashed-backslash-atpt
slashed-brace-atpt
slashed-bracket-atpt
slashed-dollar-atpt
slashed-doublequote-atpt
slashed-parentize-atpt
slashed-separate-atpt
slashed-singlequote-atpt
slashed-slash-atpt
slashed-comment-atpt
space-backslash-atpt
space-brace-atpt
space-bracket-atpt
space-dollar-atpt
space-doublequote-atpt
space-parentize-atpt
space-separate-atpt
space-singlequote-atpt
space-slash-atpt
space-comment-atpt
string-backslash-atpt
string-brace-atpt
string-bracket-atpt
string-dollar-atpt
string-doublequote-atpt
string-parentize-atpt
string-separate-atpt
string-singlequote-atpt
string-slash-atpt
string-comment-atpt
sh-struct-backslash-atpt
sh-struct-brace-atpt
sh-struct-bracket-atpt
sh-struct-dollar-atpt
sh-struct-doublequote-atpt
sh-struct-parentize-atpt
sh-struct-separate-atpt
sh-struct-singlequote-atpt
sh-struct-slash-atpt
sh-struct-comment-atpt
symbol-backslash-atpt
symbol-brace-atpt
symbol-bracket-atpt
symbol-dollar-atpt
symbol-doublequote-atpt
symbol-parentize-atpt
symbol-separate-atpt
symbol-singlequote-atpt
symbol-slash-atpt
symbol-comment-atpt
unibyte-backslash-atpt
unibyte-brace-atpt
unibyte-bracket-atpt
unibyte-dollar-atpt
unibyte-doublequote-atpt
unibyte-parentize-atpt
unibyte-separate-atpt
unibyte-singlequote-atpt
unibyte-slash-atpt
unibyte-comment-atpt
upper-backslash-atpt
upper-brace-atpt
upper-bracket-atpt
upper-dollar-atpt
upper-doublequote-atpt
upper-parentize-atpt
upper-separate-atpt
upper-singlequote-atpt
upper-slash-atpt
upper-comment-atpt
url-backslash-atpt
url-brace-atpt
url-bracket-atpt
url-dollar-atpt
url-doublequote-atpt
url-parentize-atpt
url-separate-atpt
url-singlequote-atpt
url-slash-atpt
url-comment-atpt
whitespace-backslash-atpt
whitespace-brace-atpt
whitespace-bracket-atpt
whitespace-dollar-atpt
whitespace-doublequote-atpt
whitespace-parentize-atpt
whitespace-separate-atpt
whitespace-singlequote-atpt
whitespace-slash-atpt
whitespace-comment-atpt
word-backslash-atpt
word-brace-atpt
word-bracket-atpt
word-dollar-atpt
word-doublequote-atpt
word-parentize-atpt
word-separate-atpt
word-singlequote-atpt
word-slash-atpt
word-comment-atpt
xdigit-backslash-atpt
xdigit-brace-atpt
xdigit-bracket-atpt
xdigit-dollar-atpt
xdigit-doublequote-atpt
xdigit-parentize-atpt
xdigit-separate-atpt
xdigit-singlequote-atpt
xdigit-slash-atpt
xdigit-comment-atpt)))
    (dolist (elt fns-test)
      (message "   %s" elt)
      (funcall elt arg)
      (sit-for th-delimtest-delay)))
  (undo))

(provide 'th-utils-test)
;;; th-utils-test.el ends here
